import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The game board. The board had a paddle that can move.
 * 
 * @author mik
 * @version 1.0
 */
public class Board extends World
{
    private static final int GAP = 12;

    private Paddle paddle;
    private BlockCounter blockcounter;
    
    /**
     * Constructor for objects of class Board.
     * 
     */
    public Board()
    {    
        super(460, 460, 1);
        setPaintOrder ( Ball.class, Smoke.class );

        blockcounter = new BlockCounter();
        addObject (blockcounter, 113, 440);

        paddle = new Paddle();
        addObject ( paddle, getWidth() / 2, getHeight() - 40);

        createBlocks();
    }

    /**
     * Create the blocks at the top of the world.
     */
    private void createBlocks()
    {
        int y = 30;

        while ( y <= 94 ) {
            createRow(y);
            y = y + 20 + GAP;
        }
    }

    private void createRow(int y)
    {
        int x = 50;
        while ( x < 460 ) 
        {
            addObject( new Block(), x, y);
            x = x + 60 + GAP;
        }
    }

    public void ballIsOut()
    {
        paddle.newBall();
    }

    public void score()
    {
        blockcounter.addScore();
    }
}
